// ==UserScript==
// @name Add-On 2fight
// @namespace http://www.2fighteur.com
// @description Rajoute des fonctionnalites au jeu 2fight.
// @include http://www.2fight.com/*
// ==/UserScript==


// --------------------------------------------------------------------
//
// Script By Win for 2fighteur
// Merci a Cary, sangio et Mazzu
// http://www.2fighteur.com
//
//
// Liste des fonctionnalites de la version actuelle :
//
// - Enleve le lien "Gratuit: Sortir TOUS tes persos de leurs villes".
// - Les pages "Capsules", "Objets"... ont maintenant la meme taille que les autres.
// - Efface les liens qui font sortir vos personnages afin de ne pas vous faire pieger (postes sur le forum, dans une signature ou envoye par un autre joueur par exemple).
// - Rajout d'un lien vers 2fighteur.
// - Supprime les liens de parrainage present sur le jeu.
// - Rajout des smileys lorsqu'on ecrit un message sur le forum.
// - Activez/deactivez les options une par une comme vous le souhaitez.
//
// En projet pour une nouvelle version :
//
// - Vous previens lorsqu'une mise a jours de l'Add-On est disponible.
//
// --------------------------------------------------------------------

// enregistrer une valeur dans localStorage
function GM_setValue(key, value) {
	chrome.extension.sendRequest({setValue: key + "=" + value});
}


function isElt(noderef) {
	return (noderef.nodeType == 1);
}

function getNextElt(noderef) {
	var tmp = noderef.nextSibling;
	while ((!!tmp) && (!isElt(tmp))) {
		tmp = tmp.nextSibling;
	}
	return tmp;
}

function getFirstElt(noderef) {
	var tmp = noderef.firstChild;
	if ((!!tmp) && (!isElt(tmp))) {
		return getNextElt(tmp);
	}
	return tmp;
}

function getPrevElt(noderef) {
	var tmp = noderef.previousSibling;
	while ((!!tmp) && (!isElt(tmp))) {
		tmp = tmp.previousSibling;
	}
	return tmp;
}

function getLastElt(noderef) {
	var tmp = noderef.lastChild;
	if ((!!tmp) && (!isElt(tmp))) {
		return getPrevElt(tmp);
	}
	return tmp;
}

function getParent(noderef, count) {
	if (!count) { // 0 ou undefined
		return noderef.parentNode;
	}

	var tmp = noderef;
	for (var i = 0; i < count; i++) {
		tmp = tmp.parentNode;
	}
	return tmp;
}

function getFirstTag(noderef, tagname) {
	var tmp = noderef.getElementsByTagName(tagname);
	return (tmp.length == 0) ? null : tmp[0];
}


// Creer un lien (seul le premier argument est obligatoire : url)
function createLink(url, txt, target) {
	var link = document.createElement("a");
	if (target) {
		link.target = target;
	}
	link.href = url;
	link.appendChild(document.createTextNode(txt ? txt : url));

	link.normalize();
	return link;
}

// Creer une section de menu
function createMenuSection(txt) {
	var menuSection = document.createElement("h4");
	menuSection.appendChild(document.createTextNode(txt));
	menuSection.normalize();
	return menuSection;
}

// Injecter des styles CSS dans la page.
function injectCSS(cssdata) {
	var head = document.getElementsByTagName("head")[0];
	var style = document.createElement("style");
	style.setAttribute("type", "text/css");
	style.innerHTML = cssdata;
	head.appendChild(style);
}

function getTextArea(n) {
	return document.getElementById("brd-wrap").getElementsByTagName("textarea")[n];
}


/**
  * From http://www.faqts.com/knowledge_base/view.phtml/aid/1052/fid/130
  */
function storeCaret(textEl) {
	if (textEl.createTextRange) {
		textEl.caretPos = document.selection.createRange().duplicate();
	}
}


/**
  * From http://www.massless.org/mozedit/
  */
function mozWrap(txtarea, open, close) {
	var selLength = (typeof(txtarea.textLength) == 'undefined') ? txtarea.value.length : txtarea.textLength;
	var selStart = txtarea.selectionStart;
	var selEnd = txtarea.selectionEnd;
	var scrollTop = txtarea.scrollTop;

	if (selEnd == 1 || selEnd == 2) {
		selEnd = selLength;
	}

	var s1 = (txtarea.value).substring(0,selStart);
	var s2 = (txtarea.value).substring(selStart, selEnd);
	var s3 = (txtarea.value).substring(selEnd, selLength);

	txtarea.value = s1 + open + s2 + close + s3;
	txtarea.selectionStart = selEnd + open.length + close.length;
	txtarea.selectionEnd = txtarea.selectionStart;
	txtarea.focus();
	txtarea.scrollTop = scrollTop;

	return;
}


function insertSmiley(evt) {
	var image = this.getAttribute("title");
	var elt = getTextArea(this.getAttribute("gult"));

	// From phpbb.com
	if (!isNaN(elt.selectionStart)) {
		var sel_start = elt.selectionStart;
		var sel_end = elt.selectionEnd;
		mozWrap(elt, image, '');
		elt.selectionStart = sel_start + image.length;
		elt.selectionEnd = sel_end + image.length;
	} else if (elt.createTextRange && elt.caretPos) {
		if (document.selection.createRange().duplicate().boundingHeight != elt.caretPos.boundingHeight) {
			elt.focus();
			storeCaret(elt);
		}
		var caret_pos = elt.caretPos;
		caret_pos.text = caret_pos.text.charAt(caret_pos.text.length - 1) == ' ' ? caret_pos.text + image + ' ' : caret_pos.text + image;
	} else {
		elt.value = elt.value + image;
	}

	elt.focus();
}

function forumSmileys() {
	var smiley = [
		{ "title": ":)", "src": "/forums/img/smilies/smile.gif" },
		{ "title": ":|", "src": "/forums/img/smilies/neutral.gif" },
		{ "title": ":(", "src": "/forums/img/smilies/evil.gif" },
		{ "title": ":`(", "src": "/forums/img/smilies/cry.gif" },
		{ "title": "=(", "src": "/forums/img/smilies/sad.png" },
		{ "title": ":D", "src": "/forums/img/smilies/big_smile.png" },
		{ "title": ":o", "src": "/forums/img/smilies/surprised.gif" },
		{ "title": "o_o", "src": "/forums/img/smilies/eek.gif" },
		{ "title": ";)", "src": "/forums/img/smilies/wink.png" },
		{ "title": ":/", "src": "/forums/img/smilies/hmm.png" },
		{ "title": ":P", "src": "/forums/img/smilies/tongue.png" },
		{ "title": ":lol:", "src": "/forums/img/smilies/lol.gif" },
		{ "title": ":rolleyes:", "src": "/forums/img/smilies/rolleyes.gif" },
		{ "title": ":cool:", "src": "/forums/img/smilies/cool.png" },
		{ "title": ":$", "src": "/forums/img/smilies/redface.gif" },
		{ "title": "->", "src": "/forums/img/smilies/arrow.gif" },
		{ "title": "o=", "src": "/forums/img/smilies/idea.gif" },
		{ "title": ":?:", "src": "/forums/img/smilies/question.gif" },
		{ "title": ":!:", "src": "/forums/img/smilies/exclaim.gif" },
		{ "title": ":chaoz:", "src": "/forums/img/smilies/chaoz.png" },
		{ "title": ":krilin:", "src": "/forums/img/smilies/krilin.png" },
		{ "title": ":kurririn:", "src": "/forums/img/smilies/kurririn.png" },
		{ "title": ":gohan:", "src": "/forums/img/smilies/gohan.png" },
		{ "title": ":gohanssj:", "src": "/forums/img/smilies/gohanssj.png" },
		{ "title": ":gokussj:", "src": "/forums/img/smilies/gokussj.png" },
		{ "title": ":piccolo:", "src": "/forums/img/smilies/piccolo.png" },
		{ "title": ":tenshi:", "src": "/forums/img/smilies/tenshi.png" },
		{ "title": ":trunks:", "src": "/forums/img/smilies/trunks.png" },
		{ "title": ":vegeta:", "src": "/forums/img/smilies/vegeta.png" },
		{ "title": ":vegetassj:", "src": "/forums/img/smilies/vegetassj.png" },
		{ "title": ":cell:", "src": "/forums/img/smilies/cell.png" }
	];

	var tb = document.getElementById("brd-wrap").getElementsByTagName("textarea");
	var text, d, mm, i, j;
	for (i = 0; i < tb.length; i++) {
		text = tb[i];
		if (!text) { return; }
		d = document.createElement("div");
		d.className = "twofighteurtxt";
		d.align = "left";

		getFirstElt(getFirstElt(getParent(text, 3))).appendChild(d);

		for (j = 0; j < smiley.length; j++) {
			mm = document.createElement("img");
			mm.src = smiley[j].src;
			mm.title = smiley[j].title;
			mm.setAttribute("gult", i);
			mm.addEventListener("click", insertSmiley, true);
			d.appendChild(mm);
			d.appendChild(document.createTextNode(" "));
		}

		d.normalize();
	}
}

function getmenucadre(menuid) {
	var menu = document.getElementById(menuid);
	if (!menu) {
		return null;
	}

	var divs = menu.getElementsByTagName("div");
	if (divs.length == 0) {
		return null;
	}
	return divs[0];
}

function add2fighteurlink() {
	var cadre = getmenucadre("tm_amis");
	if (!cadre) {
		return;
	}

	var titreSiteAide = document.createElement("h4");
	titreSiteAide.appendChild(document.createTextNode("Site d'aide"));
    titreSiteAide.normalize();

	var nextentry = getFirstElt(cadre);
	while ((!!nextentry) && (nextentry.className != "last")) {
		nextentry = getNextElt(nextentry);
	}

	var link2Fighteur = createLink("http://www.2fighteur.com/", "2fighteur", "_blank");

	if (!nextentry) {
		cadre.appendChild(titreSiteAide);
		cadre.appendChild(link2Fighteur);
	} else {
		cadre.insertBefore(titreSiteAide, nextentry);
		cadre.insertBefore(link2Fighteur, nextentry);
	}
}


// Supprime toutes les occurrences d'elements dont XPath est fourni dans le document.
function removeElement(ElementXpath) {
	var alltags = document.evaluate(ElementXpath, document, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	var element;
	for (var i = 0; i < alltags.snapshotLength; i++) {
		element = alltags.snapshotItem(i);
		element.parentNode.removeChild(element); // Remove this element from its parent.
	}
}

// Supprime un attribut de toutes les occurrences d'elements dont XPath est fourni.
// (Toutes les occurrences de cet element sont traites.)
function removeAttributeOfElement(attributeName, ElementXpath) {
	var alltags = document.evaluate(ElementXpath, document, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	for (var i = 0; i < alltags.snapshotLength; i++) {
		alltags.snapshotItem(i).removeAttribute(attributeName);
	}
}

// Definir un attribut de toutes les occurrences d'elements a une valeur determinee.
// La valeur precedente de cet attribut est ignore.
// (Toutes les occurrences de cet element sont traites.)
function setAttributeOfElement(attributeName, attributeValue, ElementXpath) {
	var alltags = document.evaluate(ElementXpath, document, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	for (var i = 0; i < alltags.snapshotLength; i++) {
		alltags.snapshotItem(i).setAttribute(attributeName, attributeValue);
	}
}

// Rajoute des elements
function insertElement(textinsert, ElementXpath) {
	var alltags = document.evaluate(ElementXpath, document, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	for (var i = 0; i < alltags.snapshotLength; i++) {
		alltags.snapshotItem(i).innerHTML += textinsert;
		alltags.snapshotItem(i).normalize();
	}
}

// Re-ecrit un element
function rewriteElement(textinsert, ElementXpath) {
	var alltags = document.evaluate(ElementXpath, document, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	for (var i = 0; i < alltags.snapshotLength; i++) {
		alltags.snapshotItem(i).innerHTML = textinsert;
		alltags.snapshotItem(i).normalize();
	}
}


// Fonction de retrait des liens de parrainage
function removeParrainages() {
	var links = document.getElementsByTagName("a");
	var i, elt, tmp, href, remove = [];
	for (i = 0; i < links.length; i++) {
		elt = links[i];
		href = elt.href;
		if ((href.substring(0, 22) == "http://www.2fight.com/") && (href.indexOf("par_num=") >= 0)) {
			// Remove this element from its parent.
			remove.push(elt);
		}
	}
	links = null;
	for (i = 0; i < remove.length; i++) {
		tmp = remove[i].parentNode;
		tmp.removeChild(remove[i]);
		remove[i] = null;
	}
}

// Laisse le design toujours a la meme taile (pour les pages "Capsules", "Objets", ...) NE FONCTIONNE PAS POUR LA PAGE FORUM (volontaire).
function taillepagemin() {
	injectCSS('body#largeDesign #AllAll { width: 990px; }');
	injectCSS('body#largeDesign { background: #d6dbe1 url(/images/design/wholebg.png) top center no-repeat; }');

	// page capsule => modifier le filtre pour qu'il tienne en largeur
	var addr = "http://www.2fight.com/index.php?page=capsules";
	if(window.location.href.substring(0, addr.length) == addr) {
		for(var i=0; i<document.forms.length; i++) {
			if(document.forms[i].name == "caps_filter") {
				var txt = document.forms[i].innerHTML;
				txt = txt.replace(/&nbsp;/g," ");
				document.forms[i].innerHTML = txt;
			}
		}
	}
}

(function () {

	var path = document.location.pathname;
	var divAllAll = document.getElementById("AllAll");
	if(!divAllAll) {
		 // on est sur une image, un code source... ou le forum
		if(path.indexOf("/forums/") < 0) {
			// on est sur une image, un code source... l'add-on ne s'applique pas
			return;
		}
	}

	// taillepage
	chrome.extension.sendRequest({valueOf: "taillepage"}, function(response) {
		var e, valeur = response.value;
		if(valeur == null || valeur == "true") {
			try {
				// toutes les pages largeur 990px (sauf forum)
				taillepagemin();
			} catch (e) {
				alert("Add-On 2fight erreur (1) :\n" + e);
			}
		}
	});

	// smileys
	if ((path == "/forums/post.php") || (path == "/forums/edit.php")) {
		chrome.extension.sendRequest({valueOf: "smileys"}, function(response) {
			var e, valeur = response.value;
			if(valeur == null || valeur == "true") {
				try {
					forumSmileys();
				} catch (e) {
					alert("Add-On 2fight erreur (2) :\n" + e);
				}
			}
		});
	}

	// sortirperso
	chrome.extension.sendRequest({valueOf: "sortirperso"}, function(response) {
		var e, valeur = response.value;
		if(valeur == null || valeur == "true") {
			try {
				// Suppression lien "Gratuit: Sortir TOUS tes persos de leurs villes" du menu "Fight".
				removeElement("//a[@href='/index.php?page=carte&out_of_town=1']");
			} catch (e) {
				alert("Add-On 2fight erreur (3) :\n" + e);
			}
		}
	});

	// lien2fighteur
	chrome.extension.sendRequest({valueOf: "lien2fighteur"}, function(response) {
		var e, valeur = response.value;
		if(valeur == null || valeur == "true") {
			try {
				// Insertion d'un lien vers 2fighteur dans le menu "Amis"
				add2fighteurlink();
			} catch (e) {
				alert("Add-On 2fight erreur (4) :\n" + e);
			}
		}
	});

	// supprparrainage
	chrome.extension.sendRequest({valueOf: "supprparrainage"}, function(response) {
		var e, valeur = response.value;
		if(valeur == null || valeur == "true") {
			try {
				// Retire les liens de parrainages
				removeParrainages();
			} catch (e) {
				alert("Add-On 2fight erreur (6) :\n" + e);
			}
		}
	});

})();

